// FO_VALUE.cpp: implementation of the FO_VALUE class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "FO_VALUE.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

FO_VALUE::FO_VALUE()
{
	// BOOL value
	m_bValue		= TRUE;

	// String value
	m_strValue		= _T("");

	// Int value
	m_nValue		= 0;

	// Float value
	m_fValue		= 0.0f;

	// Double value
	m_dValue		= 0.0;

	// DWORD value
	m_dwValue		= 0;

	// Date time value
	m_dtValue		= COleDateTime::GetCurrentTime();

	// Color value
	m_crValue		= 0;

	// Value type.
	m_nValueType	= V_BOOL;
}

FO_VALUE::FO_VALUE(const CString& str)
{
	// BOOL value
	m_bValue		= TRUE;

	// String value
	m_strValue		= str;

	// Int value
	m_nValue		= 0;

	// Float value
	m_fValue		= 0.0f;

	// Double value
	m_dValue		= 0.0;

	// DWORD value
	m_dwValue		= 0;

	// Date time value
	m_dtValue		= COleDateTime::GetCurrentTime();

	// Color value
	m_crValue		= 0;

	// Value type.
	m_nValueType	= V_STRING;
}

FO_VALUE::FO_VALUE(const FO_VALUE& val)
{
	m_bValue			=	val.m_bValue;
	m_strValue			=	val.m_strValue;
	m_nValue			=	val.m_nValue;
	m_fValue			=	val.m_fValue;
	m_dValue			=	val.m_dValue;
	m_dwValue			=	val.m_dwValue;
	m_dtValue			=	val.m_dtValue;
	m_crValue			=	val.m_crValue;
	m_nValueType		=	val.m_nValueType;
}


FO_VALUE::~FO_VALUE()
{
}

FO_VALUE& FO_VALUE::operator=(const FO_VALUE& val)
{
	m_bValue			=	val.m_bValue;
	m_strValue			=	val.m_strValue;
	m_nValue			=	val.m_nValue;
	m_fValue			=	val.m_fValue;
	m_dValue			=	val.m_dValue;
	m_dwValue			=	val.m_dwValue;
	m_dtValue			=	val.m_dtValue;
	m_crValue			=	val.m_crValue;
	m_nValueType		=	val.m_nValueType;
	return *this;
}

void FO_VALUE::SerializeData(CArchive &ar)
{
	if(ar.IsStoring())
	{
		ar << m_bValue;
		ar << m_strValue;
		ar <<(int)m_nValue;
		ar <<(float)m_fValue;
		ar <<(double)m_dValue;
		ar <<(DWORD)m_dwValue;
		ar << m_dtValue;
		ar << m_crValue;
		ar <<(int)m_nValueType;
	}
	else
	{
		ar >> m_bValue;
		ar >> m_strValue;
		int nTemp;
		ar >> nTemp;
		m_nValue = nTemp;
		float fValue;
		ar >> fValue;
		m_fValue = fValue;
		double dValue;
		ar >> dValue;
		m_dValue = dValue;
		DWORD dwValue;
		ar >> dwValue;
		m_dwValue = dwValue;

		ar >> m_dtValue;
		ar >> m_crValue;
		ar >> nTemp;
		m_nValueType =(FO_VALUETYPE)nTemp;
	}
}

BOOL FO_VALUE::operator==(const FO_VALUE val) const
{
	FO_VALUE nTemp = val;
	if(IsEqual(&nTemp))
	{
		return TRUE;
	}
	return FALSE;
}

BOOL FO_VALUE::IsEqual(FO_VALUE* value) const
{
	switch(m_nValueType)
	{
		case V_BOOL:
		{
			if(m_bValue == value->m_bValue)
			{
				return TRUE;
			}
		}
		break;

	case V_INT:
		{
			if(m_nValue == value->m_nValue)
			{
				return TRUE;
			}
		}
		break;

	case V_STRING:
		{
			if(m_strValue == value->m_strValue)
			{
				return TRUE;
			}
		}
		break;

	case V_FLOAT:
		{
			if(m_fValue == value->m_fValue)
			{
				return TRUE;
			}
		}
		break;

	case V_DOUBLE:
		{
			if(m_dValue == value->m_dValue)
			{
				return TRUE;
			}
		}
		break;

	case V_DWORD:
		{
			if(m_dwValue == value->m_dwValue)
			{
				return TRUE;
			}
		}
		break;

	case V_DATETIME:
		{
			if(m_dtValue == value->m_dtValue)
			{
				return TRUE;
			}
		}
		break;

	case V_COLOR:
		{
			if(m_crValue == value->m_crValue)
			{
				return TRUE;
			}
		}
		break;
	}

	return FALSE;
}
