// FO_VALUE.h: interface for the FO_VALUE class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FO_VALUE_H__CF288EA5_81FB_44C8_ADF1_FED8280AD24B__INCLUDED_)
#define AFX_FO_VALUE_H__CF288EA5_81FB_44C8_ADF1_FED8280AD24B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


enum FO_VALUETYPE
{
	V_EMPTY = -1,
	V_BOOL,		// BOOL value type.
	V_STRING,	// String value type
	V_INT,		// int value type
	V_FLOAT,	// float value type
	V_DOUBLE,	// double value type
	V_DWORD,	// DWORD value type
	V_DATETIME,	// COleDateTime value type
	V_COLOR		// COLORREF value type.
};

//////////////////////////////////////////////////////////////////////
// FO_VALUE a class define for property value that Form++ support.
//

class FO_VALUE
{
public:
	// Constructor.
	FO_VALUE();

	// String Constructor.
	FO_VALUE(const CString& str);

	// Copy Constructor.
	FO_VALUE(const FO_VALUE& val);

	// Destrutctor.
	~FO_VALUE();

	// Is equal.
	virtual BOOL IsEqual(FO_VALUE* value) const;

	// Determines if another set of fill properties is equal to this one. 
	BOOL operator==(const FO_VALUE val) const;

	// =
	virtual FO_VALUE& operator=(const FO_VALUE& val);

	// Serialize data.
	void SerializeData(CArchive &ar);

public:
	
	// BOOL value.
	BOOL		m_bValue;

	// String value.
	CString		m_strValue;

	// Int value.
	int			m_nValue;

	// Float value.
	float		m_fValue;

	// Double value.
	double		m_dValue;

	// DWORD value.
	DWORD		m_dwValue;

	// Date time value.
	COleDateTime m_dtValue;

	// Color value.
	COLORREF	m_crValue;

	// Value type.
	FO_VALUETYPE m_nValueType;
};


#endif // !defined(AFX_FO_VALUE_H__CF288EA5_81FB_44C8_ADF1_FED8280AD24B__INCLUDED_)
